//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+
#include <common.mqh>
#define        MAXORDERS            5
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

extern int MagicNumber = 27374;
extern bool SignalMail = False;
extern bool EachTickMode = True;
extern double Lots = 0.01;
extern int Slippage = 3;
extern bool UseStopLoss = True;
extern int StopLoss = 300;
extern bool UseTakeProfit = False;
extern int TakeProfit = 60;
extern bool UseTrailingStop = True;
extern int TrailingStop = 30;


int BarCount;
int Current;
bool TickCheck = False;
bool tickvalue;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;
   
   //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   return(0);

}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {


   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double InitialSL, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
   

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+





   double high30  = iHigh(NULL,30,0);
   double low30   = iLow(NULL,30,0);
   double close30 = iClose(NULL,30,0);
   double open30  = iOpen(NULL,30,0);
   double P30 = (high30+low30+close30)/3;
   
   double high31  = iHigh(NULL,30,1);
   double low31   = iLow(NULL,30,1);
   double close31 = iClose(NULL,30,1);
   double open31  = iOpen(NULL,30,1);
   double P31 = (high31+low31+close31)/3;
   
   double high32  = iHigh(NULL,30,2);
   double low32   = iLow(NULL,30,2);
   double close32 = iClose(NULL,30,2);
   double open32  = iOpen(NULL,30,2);
   double P32 = (high32+low32+close32)/3;   
   
   double high60  = iHigh(NULL,60,0);
   double low60   = iLow(NULL,60,0);
   double close60 = iClose(NULL,60,0);
   double open60  = iOpen(NULL,60,0);
   double P60 = (high60+low60+close60)/3;

   double high61  = iHigh(NULL,60,1);
   double low61   = iLow(NULL,60,1);
   double close61 = iClose(NULL,60,1);
   double open61  = iOpen(NULL,60,1);
   double P61 = (high61+low61+close61)/3;   

   double high62  = iHigh(NULL,60,2);
   double low62   = iLow(NULL,60,2);
   double close62 = iClose(NULL,60,2);
   double open62  = iOpen(NULL,60,2);
   double P62 = (high62+low62+close62)/3; 
   
   double high240  = iHigh(NULL,240,0);
   double low240   = iLow(NULL,240,0);
   double close240 = iClose(NULL,240,0);
   double open240  = iOpen(NULL,240,0);
   double P240 = (high240+low240+close240)/3;
   
   double high241  = iHigh(NULL,240,1);
   double low241   = iLow(NULL,240,1);
   double close241 = iClose(NULL,240,1);
   double open241  = iOpen(NULL,240,1);
   double P241 = (high241+low241+close241)/3;

   double high242  = iHigh(NULL,240,2);
   double low242   = iLow(NULL,240,2);
   double close242 = iClose(NULL,240,2);
   double open242  = iOpen(NULL,240,2);
   double P242 = (high242+low242+close242)/3;

     
   
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

            

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

            

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+
 
     
     
     
//========================30min bars========================     
     
      if (close32<open32 && close31>open31 && open30> open31)Order = SIGNAL_BUY;
      if (close32>open32 && close31<open31 && open30< open31) Order = SIGNAL_SELL;
      
      if (open31<close32 && close31>open31 && open30< close31)Order = SIGNAL_BUY;
      if (open31>close32 && close31<open31 && open30> close31) Order = SIGNAL_SELL;
      
      if (open31>open32 && open30>open31) Order = SIGNAL_BUY;
      if (open31<open32 && open30<open31)Order = SIGNAL_SELL;      
      
      if (open30>close31) Order = SIGNAL_BUY;
      if (open30<close31) Order = SIGNAL_SELL;
      
      if (low30<low31 && open30>close31)Order = SIGNAL_BUY;
      if (high30>high31 && open30<close31) Order = SIGNAL_SELL;
      
      if (open31<low32 && close31>open31 && open30>P31)Order = SIGNAL_BUY; 
      if (open31>high32 && close31<open31 && open30<P31) Order = SIGNAL_SELL;
      
      if (high30>high31 && open30>close31)Order = SIGNAL_BUY; 
      if (low30<low31 && open30<close31) Order = SIGNAL_SELL;
      
      if (open31==low31 && close31>open31)Order = SIGNAL_BUY; 
      if (open31==high31 && close31<open31) Order = SIGNAL_SELL;
      
      
//========================60min bars=======================================      
      
      if (close62<open62 && close61>open61 && open60> open61)Order = SIGNAL_BUY;
      if (close62>open62 && close61<open61 && open60< open61) Order = SIGNAL_SELL;
      
      if (open61<close62 && close61>open61 && open60< close61)Order = SIGNAL_BUY;
      if (open61>close62 && close61<open61 && open60> close61) Order = SIGNAL_SELL;
      
      if (open61>open62 && open60>open61) Order = SIGNAL_BUY;
      if (open61<open62 && open60<open61)Order = SIGNAL_SELL;      
      
      if (open60>close61) Order = SIGNAL_BUY;
      if (open60<close61)Order = SIGNAL_SELL;
      
      if (low60<low61 && open60>close61)Order = SIGNAL_BUY;
      if (high60>high61 && open60<close61) Order = SIGNAL_SELL;
      
      if (open61<low62 && close61>open61 && open60>P61)Order = SIGNAL_BUY; 
      if (open61>high62 && close61<open61 && open60<P61) Order = SIGNAL_SELL;
      
      if (high60>high61 && open60>close61)Order = SIGNAL_BUY; 
      if (low60<low61 && open60<close61) Order = SIGNAL_SELL;
      
      if (open61==low61 && close61>open61)Order = SIGNAL_BUY; 
      if (open61==high61 && close61<open61) Order = SIGNAL_SELL;
      
      
//========================240min bars=======================================      
      
      if (close242<open242 && close241>open241 && open240> open241)Order = SIGNAL_BUY;
      if (close242>open242 && close241<open241 && open240< open241) Order = SIGNAL_SELL;
      
      if (open241<close242 && close241>open241 && open240< close241)Order = SIGNAL_BUY;
      if (open241>close242 && close241<open241 && open240> close241) Order = SIGNAL_SELL;
      
      if (open241>open242 && open240>open241)Order = SIGNAL_BUY;
      if (open241<open242 && open240<open241) Order = SIGNAL_SELL;      
      
      if (open240>close241)Order = SIGNAL_BUY;
      if (open240<close241) Order = SIGNAL_SELL;
      
      if (low240<low241 && open240>close241)Order = SIGNAL_BUY;
      if (high240>high241 && open240<close241) Order = SIGNAL_SELL;
      
      if (open241<low242 && close241>open241 && open60>P241)Order = SIGNAL_BUY; 
      if (open241>high242 && close241<open241 && open60<P241) Order = SIGNAL_SELL;
      
      if (high240>high241 && open240>close241)Order = SIGNAL_BUY; 
      if (low240<low241 && open240<close241) Order = SIGNAL_SELL;
      
      if (open241==low241 && close241>open241)Order = SIGNAL_BUY; 
      if (open241==high241 && close241<open241) Order = SIGNAL_SELL;

 


   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) InitialSL = Ask - StopLoss * Point; else InitialSL = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;
         Lots = lotsOptimized(InitialSL*Point);
         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, InitialSL, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) InitialSL = Bid + StopLoss * Point; else InitialSL = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;
         Lots = lotsOptimized(InitialSL*Point);
         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, InitialSL, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}



//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int Magic_Number, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "AUDCAD")       isymbol = 1;
   else if (symbol == "AUDCHF")  isymbol = 2;
   else if (symbol == "AUDJPY")  isymbol = 3;
   else if (symbol == "AUDDKK")  isymbol = 4;
   else if (symbol == "AUDNZD")  isymbol = 5;
   else if (symbol == "AUDPLN")  isymbol = 6;
   else if (symbol == "AUDSGD")  isymbol = 7;
   else if (symbol == "AUDUSD")  isymbol = 8;
   else if (symbol == "CADCHF")  isymbol = 9;
   else if (symbol == "CADJPY")  isymbol = 10;
   else if (symbol == "CHFCAD")  isymbol = 11;
   else if (symbol == "CHFJPY")  isymbol = 12;
   else if (symbol == "CHFSGD")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "EURCHF")  isymbol = 16;
   else if (symbol == "EURDKK")  isymbol = 17;
   else if (symbol == "EURGBP")  isymbol = 18;
   else if (symbol == "EURHKD")  isymbol = 19;
   else if (symbol == "EURHUF")  isymbol = 20;
   else if (symbol == "EURJPY")  isymbol = 21;
   else if (symbol == "EURLVL")  isymbol = 22;
   else if (symbol == "EURNOK")  isymbol = 23;
   else if (symbol == "EURNZD")  isymbol = 24;
   else if (symbol == "EURPLN")  isymbol = 25;
   else if (symbol == "EURSEK")  isymbol = 26;
   else if (symbol == "EURSGD")  isymbol = 27;
   else if (symbol == "EURSKK")  isymbol = 28;
   else if (symbol == "EURUSD")  isymbol = 29;
   else if (symbol == "EURZAR")  isymbol = 30;
   else if (symbol == "GBPAUD")  isymbol = 31;
   else if (symbol == "GBPCAD")  isymbol = 32;
   else if (symbol == "GBPCHF")  isymbol = 33;
   else if (symbol == "GBPDKK")  isymbol = 34;
   else if (symbol == "GBPJPY")  isymbol = 35;
   else if (symbol == "GBPNOK")  isymbol = 36;
   else if (symbol == "GBPNZD")  isymbol = 37;
   else if (symbol == "GBPSEK")  isymbol = 38;
   else if (symbol == "GBPSGD")  isymbol = 39;
   else if (symbol == "GBPUSD")  isymbol = 40;
   else if (symbol == "GBPZAR")  isymbol = 41;
   else if (symbol == "NZDCAD")  isymbol = 42;
   else if (symbol == "NZDCHF")  isymbol = 43;
   else if (symbol == "NZDJPY")  isymbol = 44;
   else if (symbol == "NZDSGD")  isymbol = 45;
   else if (symbol == "NZDUSD")  isymbol = 46;
   else if (symbol == "SGDJPY")  isymbol = 47;
   else if (symbol == "USDCAD")  isymbol = 48;
   else if (symbol == "USDCHF")  isymbol = 49;
   else if (symbol == "USDCCK")  isymbol = 50;
   else if (symbol == "USDDKK")  isymbol = 51;
   else if (symbol == "USDHKD")  isymbol = 52;
   else if (symbol == "USDHRK")  isymbol = 53;
   else if (symbol == "USDHUF")  isymbol = 54;
   else if (symbol == "USDJPY")  isymbol = 55;
   else if (symbol == "USDLVL")  isymbol = 56;
   else if (symbol == "USDLTL")  isymbol = 57;
   else if (symbol == "USDMXN")  isymbol = 58;
   else if (symbol == "USDNOK")  isymbol = 59;
   else if (symbol == "USDPLN")  isymbol = 60;
   else if (symbol == "USDSEK")  isymbol = 61;
   else if (symbol == "USDSGD")  isymbol = 62;
   else if (symbol == "USDSKK")  isymbol = 63;
   else if (symbol == "USDZAR")  isymbol = 64;
   else if (symbol == "#AA")  isymbol = 65;
   else if (symbol == "#AXP")  isymbol = 66;
   else if (symbol == "#BA")  isymbol = 67;
   else if (symbol == "#C")  isymbol = 68;
   else if (symbol == "#DD")  isymbol = 69;
   else if (symbol == "#DIS")  isymbol = 70;
   else if (symbol == "#AIG")  isymbol = 71;
   else if (symbol == "#GE")  isymbol = 72;
   else if (symbol == "#GM")  isymbol = 73;
   else if (symbol == "#HD")  isymbol = 74;
   else if (symbol == "#HON")  isymbol = 75;
   else if (symbol == "#HPQ")  isymbol = 76;
   else if (symbol == "#IBM")  isymbol = 77;
   else if (symbol == "#VZ")  isymbol = 78;
   else if (symbol == "#INTC")  isymbol = 79;
   else if (symbol == "#JNJ")  isymbol = 80;
   else if (symbol == "#JPM")  isymbol = 81;
   else if (symbol == "#KO")  isymbol = 82;
   else if (symbol == "#MCD")  isymbol = 83;
   else if (symbol == "#MMM")  isymbol = 84;
   else if (symbol == "#MO")  isymbol = 85;
   else if (symbol == "#MRK")  isymbol = 86;
   else if (symbol == "#MSFT")  isymbol = 87;
   else if (symbol == "#PG")  isymbol = 88;
   else if (symbol == "#T")  isymbol = 89;
   else if (symbol == "#PFE")  isymbol = 90;
   else if (symbol == "#UTX")  isymbol = 91;
   else if (symbol == "#WMT")  isymbol = 92;
   else if (symbol == "#XOM")  isymbol = 93;
   else if (symbol == "Gold")  isymbol = 94;
   else if (symbol == "Silver")  isymbol = 95;
   else if (symbol == "#EP")  isymbol = 96;
   else if (symbol == "#ENQ")  isymbol = 97;
   else if (symbol == "#YM")  isymbol = 98;
   else if (symbol == "#CL")  isymbol = 99;
   else if (symbol == "#NG")  isymbol = 100;
   else if (symbol == "#W")  isymbol = 101;
   else if (symbol == "#C")  isymbol = 102;
   else if (symbol == "#S")  isymbol = 103;
   else                          isymbol = 104;
   if(isymbol<10) Magic_Number = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}
//+------------------------------------------------------------------+